/* liste_ch.c
 * Fichier source de l'implantation des listes chainees d'entiers
 * Auteur : VOURIOT Thierry
 * Date : 5 janvier 2002
 */

#include "liste_ch.h"

/* Creation d'une nouvelle liste */
Liste listenouv(void) {
	
	Liste l=NULL;
	return l;
}

/* Adjonction en tete */
Liste adjt(Liste l, Nat x) {

	Liste l1 = MALLOC(SListe);
	l1->v = x;
	
	if (l != NULL) {
		l1->s = l->s;
		l->s = l1;	
	}
	else {
		l1->s = l1;
		l = l1;
	}
	return l;
}


/* Adjonction en queue */
Liste adjq(Liste l, Nat x) {

	Liste l1 = MALLOC(SListe);
	l1->v = x;
	
	if (l != NULL) {
		l1->s = l->s;
		l->s = l1;	
	}
	else {
		l1->s = l1;
	}
	return l1;
}

/* Suppression en tete 
 * pre suppt(l) = non vide(l)
 */
Liste suppt(Liste l) {
	
	Liste tmp = l->s;
	if (l->s == l)
		l = NULL;
	else l->s = l->s->s;
	free(tmp);
	return l;
}	
	
/* Tete 
 * pre tete(l) = non vide(l)
 */
Nat tete(Liste l) {

	return l->s->v;
}


/* Queue 
 * pre queue(l) = non vide(l)
 */
Nat queue(Liste l) {

	return l->v;
}	

/* Teste si la liste est vide */
Bool lvide(Liste list) {

	return (list == NULL);
}

/* Longueur (nbre d'elements) */
Nat lgr(Liste l) {

	Liste queue = l;
	int res = 1;
       	if (l==NULL)
		res = 0;
	else
		for (l=decg(l);queue != l;l=decg(l))
			res++;
       	return res;
}

/* Decalage circulaire vers la gauche */
Liste decg(Liste l) {

	return l->s;
}

/* Affiche la liste a l'ecran */
void laff(Liste l)
{
       	int i = lgr(l);
	Liste l1 = l;
	printf("( ");
	while (i>0) {
		printf("%d ",tete(l1));
		l1 = decg(l1);
		i--;
	}
	printf(")\n");
}

/* Element a l'indice donne 
 * pre elem(l,i) = i < lgr(l)
 */
Nat elem(Liste l, Nat i) {

	Liste l1 = l;
	int k = 0;
	while (k<i) {
		l1 = decg(l1);
		k++;
	}

	return tete(l1);
}

